% Test1: Use linear CG for Kr=w and Mr=w and tol=1e-3 and block vector
% Xini with k_+=2
clear;
close all;

load KMsih4C;
n = size(K, 1);
m = 2;n_pos=1;
I = speye(n);
% A = blkdiag(K, M);
% B = [0*I, I; I, 0*I];

tol = 1e-7;
opts.tol = tol;
flag = [1 1 1 1 1 1];

X = full(I(:, 1:m));
Y = X;
% Z = [X; Y];
% Xini = [X, X; Y, -Y];
%% zero shift

if flag(1),
msch=2; 
fprintf('indef_m_scheme_KM with m=%d. and shift=0\n',msch);
tic;
opts.nitn=200;opts.met=3;
[D2, Z2, iter2, hist2]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
t2=toc; 
fprintf('indef_m_scheme_KM with m=%d. and shift=0\n',msch);
fprintf('#(iterations) = %d.\n\n', iter2);
save('outputCGk2_tol3/output2.mat','iter2');
save('outputCGk2_tol3/output2.mat','hist2','-append');
save('outputCGk2_tol3/output2.mat','t2','-append');
end

if flag(2),
msch=3; 
fprintf('indef_m_scheme_KM with m=%d.and shift=0\n',msch);
tic;
opts.nitn=100;opts.met=3;
[D3, Z3, iter3, hist3]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
t3=toc;
fprintf('indef_m_scheme_KM with m=%d. and shift=0',msch);
fprintf('#(iterations) = %d.\n\n', iter3);
save('outputCGk2_tol3/output3.mat','iter3');
save('outputCGk2_tol3/output3.mat','hist3','-append');
save('outputCGk2_tol3/output3.mat','t3','-append');
end

if flag(3),
msch=4; 
fprintf('indef_m_scheme_KM with m=%d. and shift=0\n',msch);
tic;
opts.nitn=100;opts.met=3;
[D4, Z4, iter4, hist4]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
t4=toc;
fprintf('indef_m_scheme_KM with m=%d.\n and shift=0',msch);
fprintf('#(iterations) = %d.\n\n', iter4);
save('outputCGk2_tol3/output4.mat','iter4');
save('outputCGk2_tol3/output4.mat','hist4','-append');
save('outputCGk2_tol3/output4.mat','t4','-append');
end


if flag(4),
msch=5; 
fprintf('indef_m_scheme_KM with m=%d. and shift=0\n',msch);
tic;
opts.nitn=100;opts.met=3;
[D5, Z5, iter5, hist5]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
t5=toc;
fprintf('#(iterations) = %d.\n\n', iter5);
save('outputCGk2_tol3/output5.mat','iter5');
save('outputCGk2_tol3/output5.mat','hist5','-append');
save('outputCGk2_tol3/output5.mat','t5','-append');
end

if flag(5),
msch=6; 
fprintf('indef_m_scheme_KM with m=%d. and shift=0\n',msch);
tic;
opts.nitn=100;opts.met=3;
[D6, Z6, iter6, hist6]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
t6=toc;
fprintf('indef_m_scheme_KM with m=%d. and shift=0\n',msch);
fprintf('#(iterations) = %d.\n\n', iter6);
save('outputCGk2_tol3/output6.mat','iter6');
save('outputCGk2_tol3/output6.mat','hist6','-append');
save('outputCGk2_tol3/output6.mat','t6','-append');
end

if flag(6),
msch='whole'; 
fprintf('indef_m_scheme_KM with whole history and shift=0\n');
tic;
opts.nitn=100;opts.met=3;
[Dw, Zw, iterw, histw]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
tw=toc;
fprintf('indef_m_scheme_KM with whole history and shift=0\n');
fprintf('#(iterations) = %d.\n\n', iterw);
save('outputCGk2_tol3/outputw.mat','iterw');
save('outputCGk2_tol3/outputw.mat','histw','-append');
save('outputCGk2_tol3/outputw.mat','tw','-append');
end

m=2
hist2.step_pos
m=3
hist3.step_pos
m=4
hist4.step_pos
m=5
hist5.step_pos
m=6
hist6.step_pos
m='whole'
histw.step_pos
[2,3,4,5,6,1000;iter2,iter3,iter4,iter5,iter6,iterw]
[2,hist2.cgiter,3,hist3.cgiter,4,hist4.cgiter,5,hist5.cgiter,6,hist6.cgiter,1000,histw.cgiter]
[2, mean(hist2.K_CGITER), mean(hist2.M_CGITER),3, mean(hist3.K_CGITER), mean(hist3.M_CGITER),...
    4, mean(hist4.K_CGITER), mean(hist4.M_CGITER), 5,mean(hist5.K_CGITER), mean(hist5.M_CGITER),...
    6, mean(hist6.K_CGITER), mean(hist6.M_CGITER)]
[mean(histw.K_CGITER), mean(histw.M_CGITER)]
 max([hist2.K_CGITER,hist2.M_CGITER,hist3.K_CGITER,hist3.M_CGITER,hist4.K_CGITER,hist4.M_CGITER,hist5.K_CGITER,hist5.M_CGITER,hist6.K_CGITER,hist6.M_CGITER,histw.K_CGITER,histw.M_CGITER])

%% non-zero sfift
shift = 0.54;
opts.shift = shift;

if flag(1),
msch=2; 
fprintf('indef_m_scheme_KM with m=%d. and shift=%d.\n',msch,shift);
tic;
opts.nitn=200;opts.met=6;
[D2, Z2, iter2, hist2]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
t2=toc; 
fprintf('indef_m_scheme_KM with m=%d. and shift=%d.\n',msch,shift);
fprintf('#(iterations) = %d.\n\n', iter2);
save('outputCGk2_tol3shift/output2.mat','iter2');
save('outputCGk2_tol3shift/output2.mat','hist2','-append');
save('outputCGk2_tol3shift/output2.mat','t2','-append');
end

if flag(2),
msch=3; 
fprintf('indef_m_scheme_KM with m=%d. and shift=%d.\n',msch,shift);
tic;
opts.nitn=100;opts.met=6;
[D3, Z3, iter3, hist3]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
t3=toc;
fprintf('indef_m_scheme_KM with m=%d. and shift=%d.\n',msch,shift);
fprintf('#(iterations) = %d.\n\n', iter3);
save('outputCGk2_tol3shift/output3.mat','iter3');
save('outputCGk2_tol3shift/output3.mat','hist3','-append');
save('outputCGk2_tol3shift/output3.mat','t3','-append');
end

if flag(3),
msch=4; 
fprintf('indef_m_scheme_KM with m=%d. and shift=%d.\n',msch,shift);
tic;
opts.nitn=100;opts.met=6;
[D4, Z4, iter4, hist4]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
t4=toc;
fprintf('indef_m_scheme_KM with m=%d. and shift=%d.\n',msch,shift);
fprintf('#(iterations) = %d.\n\n', iter4);
save('outputCGk2_tol3shift/output4.mat','iter4');
save('outputCGk2_tol3shift/output4.mat','hist4','-append');
save('outputCGk2_tol3shift/output4.mat','t4','-append');
end


if flag(4),
msch=5; 
fprintf('indef_m_scheme_KM with m=%d. and shift=%d.\n',msch,shift);
tic;
opts.nitn=100;opts.met=6;
[D5, Z5, iter5, hist5]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
t5=toc;
fprintf('indef_m_scheme_KM with m=%d. and shift=%d.\n',msch,shift);
fprintf('#(iterations) = %d.\n\n', iter5);
save('outputCGk2_tol3shift/output5.mat','iter5');
save('outputCGk2_tol3shift/output5.mat','hist5','-append');
save('outputCGk2_tol3shift/output5.mat','t5','-append');
end

if flag(5),
msch=6; 
fprintf('indef_m_scheme_KM with m=%d. and shift=%d.\n',msch,shift);
tic;
opts.nitn=100;opts.met=6;
[D6, Z6, iter6, hist6]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
t6=toc;
fprintf('indef_m_scheme_KM with m=%d. and shift=%d.\n',msch,shift);
fprintf('#(iterations) = %d.\n\n', iter6);
save('outputCGk2_tol3shift/output6.mat','iter6');
save('outputCGk2_tol3shift/output6.mat','hist6','-append');
save('outputCGk2_tol3shift/output6.mat','t6','-append');
end

if flag(6),
msch='whole'; 
fprintf('indef_m_scheme_KM with whole history and shift=%d.\n',shift);
tic;
opts.nitn=100;opts.met=6;
[Dw, Zw, iterw, histw]= indef_m_scheme_KM(K,M,n_pos,X,Y,tol,opts,msch);
tw=toc;
fprintf('indef_m_scheme_KM with whole history and shift=%d.\n',shift);
fprintf('#(iterations) = %d.\n\n', iterw);
save('outputCGk2_tol3shift/outputw.mat','iterw');
save('outputCGk2_tol3shift/outputw.mat','histw','-append');
save('outputCGk2_tol3shift/outputw.mat','tw','-append');
end

[2,3,4,5,6,1000;iter2,iter3,iter4,iter5,iter6,iterw]
[2,hist2.cgiter,3,hist3.cgiter,4,hist4.cgiter,5,hist5.cgiter,6,hist6.cgiter,1000,histw.cgiter]
[2, mean(hist2.T_CGITER), 3, mean(hist3.T_CGITER), ...
    4, mean(hist4.T_CGITER), 5,mean(hist5.T_CGITER),...
    6, mean(hist6.T_CGITER)]
mean(histw.T_CGITER)
 max([hist2.T_CGITER,hist3.T_CGITER,hist4.T_CGITER,hist5.T_CGITER,hist6.T_CGITER,histw.T_CGITER])
%%
if min(flag) == 1,
figure(1);
semilogy(1:h1.deflate(1), abs(h1.ev(1:h1.deflate(1), 1)-Heig(1))/abs(Heig(1)), 'r');
hold on;
semilogy(1:h1.deflate(2), abs(h1.ev(1:h1.deflate(2), 2)-Heig(2))/abs(Heig(2)), 'b');
semilogy(1:h1.deflate(3), abs(h1.ev(1:h1.deflate(3), 3)-Heig(3))/abs(Heig(3)), 'm');
semilogy(1:h1.deflate(4), abs(h1.ev(1:h1.deflate(4), 4)-Heig(4))/abs(Heig(4)), 'k');
xlabel('iteration');
ylabel('error');
title('relative error in positive eigenvalues');
legend('Err(\lambda_1)', 'Err(\lambda_2)', 'Err(\lambda_3)', 'Err(\lambda_4)');
print('-depsc2', 'test1_1.eps');

figure(2);
semilogy(1:h2.deflate(1), abs(h2.eigen(1:h2.deflate(1), 1)-Heig(1))/abs(Heig(1)), 'r');
hold on;
semilogy(1:h2.deflate(2), abs(h2.eigen(1:h2.deflate(2), 2)-Heig(2))/abs(Heig(2)), 'b');
semilogy(1:h2.deflate(3), abs(h2.eigen(1:h2.deflate(3), 3)-Heig(3))/abs(Heig(3)), 'm');
semilogy(1:h2.deflate(4), abs(h2.eigen(1:h2.deflate(4), 4)-Heig(4))/abs(Heig(4)), 'k');
xlabel('iteration');
ylabel('error');
title('relative error in positive eigenvalues');
legend('Err(\lambda_1)', 'Err(\lambda_2)', 'Err(\lambda_3)', 'Err(\lambda_4)');
print('-depsc2', 'test1_2.eps');

figure(4);
semilogy(1:h4.deflate(1), abs(h4.ev(1:h4.deflate(1), 1)-Heig(1))/abs(Heig(1)), 'r');
hold on;
semilogy(1:h4.deflate(2), abs(h4.ev(1:h4.deflate(2), 2)-Heig(2))/abs(Heig(2)), 'b');
semilogy(1:h4.deflate(3), abs(h4.ev(1:h4.deflate(3), 3)-Heig(3))/abs(Heig(3)), 'm');
semilogy(1:h4.deflate(4), abs(h4.ev(1:h4.deflate(4), 4)-Heig(4))/abs(Heig(4)), 'k');
xlabel('iteration');
ylabel('error');
title('relative error in positive eigenvalues');
legend('Err(\lambda_1)', 'Err(\lambda_2)', 'Err(\lambda_3)', 'Err(\lambda_4)');
print('-depsc2', 'test1_4.eps');

figure(5);
semilogy(1:h5.deflate(1), abs(h5.eigen(1:h5.deflate(1), 1)-Heig(1))/abs(Heig(1)), 'r');
hold on;
semilogy(1:h5.deflate(2), abs(h5.eigen(1:h5.deflate(2), 2)-Heig(2))/abs(Heig(2)), 'b');
semilogy(1:h5.deflate(3), abs(h5.eigen(1:h5.deflate(3), 3)-Heig(3))/abs(Heig(3)), 'm');
semilogy(1:h5.deflate(4), abs(h5.eigen(1:h5.deflate(4), 4)-Heig(4))/abs(Heig(4)), 'k');
xlabel('iteration');
ylabel('error');
title('relative error in positive eigenvalues');
legend('Err(\lambda_1)', 'Err(\lambda_2)', 'Err(\lambda_3)', 'Err(\lambda_4)');
print('-depsc2', 'test1_5.eps');
end
