function [A,A1,G,J]=laplace_matrix(NN,la0)
%NN = 115;
R = 'C'; % Other possible shapes include S,N,C,D,A,H,B
GG = numgrid(R,NN);
% figure(1)
% spy(GG)
% title('A Finite Difference Grid')
 A = delsq(GG);
% figure(2)
% spy(A)
% title('The 5-point Laplacian')
% % Number of interior points
%n = sum(GG(:)>0)
n=size(A,2);
I=speye(n);
% la0=7;
A1=A-la0*I;

tic
 [G,J,err1,err2,err3]=ind_dec(A1);
td=toc;
td
fprintf('\n cond(A1)=%2.5e, cond(G)=%2.5e\n', condest(A1),condest(G))
%disp(['Dekompozicija: norme gresaka = ',num2str(err)])
[err1,err2,err3]