%% PREDUGO TRAJU ALGORITMI

n=200;
l_pos=1;l_neg=1; % number of wanted eigenpairs
k_pos=1;k_neg=1; % number of extracted eigenpairs (k_\pm >= l_\pm)
tol=1e-7;maxiter=500;
M=speye(n);
e = ones(n,1);
K = spdiags([-5*e 15*e -5*e], -1:1, n, n);
D = spdiags([-10*e 30*e -10*e], -1:1, n, n); % definiteness interval is around ( -9.4818, -0.5278)
% linearization
A=blkdiag(M, -K);B=[sparse(n,n) M;M D];%2n x 2n pencil

%% initial guess
I=speye(2*n);
II=speye(n);
%% definitizing shifts and preconditioners
mup=-0.528;
%mun=-9.47;
Tp=A-mup*B;
%Tn=A-mun*B;
% % CC = ichol(A);
% % CholeskyIC0=@(r) CC\((CC')\r);
% % InverseA=@(r) A\r;
% % T=InverseA;
% % T=CholeskyIC0;


Xini=full([[D(:,1:k_neg);-II(:,1:k_neg)],[sparse(n,k_pos);II(:,1:k_pos)]]);
%% 1. TEST: mu1p and mu1n
mu1p=-0.528;
mu1n=-9.47;
T1p=A-mu1p*B;
T1n=A-mu1n*B;


fprintf('\n Test1: Algorithm 2 (two preconditioners) with T_+ \appr inv(A-%f*B), T_-=inv(A-%f*B) and Xini \n',mu1p,mu1n);
msch=3;opts=1;
[D1, X, iter1,h1] = indef_m_scheme(A, B, T1p, T1n, Xini, k_pos, k_neg, tol, maxiter, msch,opts);
err1=norm(A*X-B*X*diag(D1))